﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using MetaFiler.Utils;

namespace MetaFiler.Controls
{
    public partial class OptionsUserControl : UserControlBase
    {
        public OptionsUserControl()
        {
            InitializeComponent();

            shellMenuRegisterButton.Enabled = !ShellExtension.IsRegisteredDirectory("MetaFiler Directory");
            unregisterButton.Enabled = !shellMenuRegisterButton.Enabled;
        }

        public override void TabPageClosing(CancelEventArgs e)
        {
            base.TabPageClosing(e);
            
            Program.DataSave("options");
        }

        private void shellMenuRegisterButton_Click(object sender, EventArgs e)
        {
            string menuCmd = "\"" + Program.exePath + "MetaFiler.exe\" -add=\"%1\"";
            ShellExtension.RegisterDirectory("MetaFiler Directory", "Add To MetaFiler", menuCmd + " -at=\"dir\"");
            ShellExtension.Register("*", "MetaFiler File", "Add To MetaFiler", menuCmd + " -at=\"file\"");

            shellMenuRegisterButton.Enabled = false;
            unregisterButton.Enabled = true;
        }

        private void unregisterButton_Click(object sender, EventArgs e)
        {
            ShellExtension.UnregisterDirectory("MetaFiler Directory");
            ShellExtension.Unregister("*", "MetaFiler File");

            shellMenuRegisterButton.Enabled = true;
            unregisterButton.Enabled = false;
        }
    }
}
