﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using MetaFiler.Utils;

namespace MetaFiler.Controls
{
    public class UserControlBase : UserControl
    {
        #region Variables

        internal TabPageEx tabPage;
        private Image tabPageImage;

        #endregion

        #region Properties

        [Browsable(true)]
        [Category("TabPage")]
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Visible)]
        public override string Text
        {
            get
            {
                return base.Text;
            }
            set
            {
                base.Text = value;
                if (tabPage != null)
                    tabPage.Text = base.Text;
            }
        }

        [Browsable(false)]
        public TabPageEx TabPage
        {
            get
            {
                return tabPage;
            }
        }

        [Category("TabPage")]
        public Image TabPageImage
        {
            get
            {
                return tabPageImage;
            }
            set
            {
                tabPageImage = value;
                if (tabPage != null)
                {
                    if (tabPageImage == null)
                    {
                        if (tabPage.TabPageImageKey != -1)
                        {
                            Program.mainForm.tabsImageList.Images.RemoveByKey(tabPage.TabPageImageKey.ToString());
                            tabPage.TabPageImageKey = -1;
                        }
                    }
                    else
                    {
                        if (tabPage.TabPageImageKey == -1)
                        {
                            tabPage.TabPageImageKey = Program.mainForm.tabPageImageKey;
                            Program.mainForm.tabsImageList.Images.Add(tabPage.TabPageImageKey.ToString(), tabPageImage);
                            Program.mainForm.tabPageImageKey++;
                        }
                        else
                        {
                            Program.mainForm.tabsImageList.Images.RemoveByKey(tabPage.TabPageImageKey.ToString());
                            Program.mainForm.tabsImageList.Images.Add(tabPage.TabPageImageKey.ToString(), tabPageImage);
                        }
                    }
                }
            }
        }

        #endregion

        #region Methods

        public virtual void TabPageClosing(CancelEventArgs e)
        {
            
        }

        #endregion

    }
}
