﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MetaFiler.Utils
{
    public static class Null
    {
        public static bool IsNull(object val)
        {
            if (val == null)
                return true;
            if (val == DBNull.Value)
                return true;

            return false;
        }

        public static int IntFromNull(object val, int defValue = 0)
        {
            if (IsNull(val))
                return defValue;

            return Convert.ToInt32(val);
        }

        public static string StringFromNull(object val, string defValue = "", bool defaultIfEmpty = true)
        {
            if (IsNull(val))
                return defValue;

            string rs = val.ToString();
            if (defaultIfEmpty & rs.Trim().Length == 0)
                return defValue;

            return rs;
        }
    }
}
