﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using MetaFiler.Controls;

namespace MetaFiler.Utils
{
    public class TabPageEx : TabPage
    {
        #region Variables

        private int tabPageImageKey = -1;

        #endregion

        #region Constructor / Destructor

        public TabPageEx(UserControlBase control) : base(control.Text)
        {
            Control = control;
            control.tabPage = this;
            if (control.TabPageImage != null)
            {
                Program.mainForm.tabsImageList.Images.Add(Program.mainForm.tabPageImageKey.ToString(),
                    control.TabPageImage);
                tabPageImageKey = Program.mainForm.tabPageImageKey;
                Program.mainForm.tabPageImageKey++;
                ImageIndex = Program.mainForm.tabsImageList.Images.IndexOfKey(tabPageImageKey.ToString());
            }

            if (!Controls.Contains(control))
            {
                Controls.Add(control);
            }

            control.Dock = DockStyle.Fill;
        }

        protected override void Dispose(bool disposing)
        {
            base.Dispose(disposing);

            if (Control != null)
            {
                CancelEventArgs e = new CancelEventArgs();
                Control.TabPageClosing(e);               
                if (Control.TabPageImage != null)
                {
                    Program.mainForm.tabsImageList.Images.RemoveByKey(tabPageImageKey.ToString());
                }
                Program.mainForm.UpdateTabImages();
            }
        }

        #endregion

        #region Properties

        [Browsable(false)]
        public int TabPageImageKey
        {
            get
            {
                return tabPageImageKey;

            }
            set
            {
                tabPageImageKey = value;
                if (tabPageImageKey == -1)
                {
                    ImageIndex = -1;
                }
                else
                {
                    ImageIndex = Program.mainForm.tabsImageList.Images.IndexOfKey(tabPageImageKey.ToString());
                }
            }
        }

        public UserControlBase Control
        {
            get; set;
        }

        #endregion
    }
}
